/* Sistemas Integrados TECNISA

Nome: 9805_CDPTRGO_LOG_CDP_RECURETAPA.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   17/02/2009 - Henrique Guidi Lobato
*/

/* Tabela RECURETAPA.*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              RECURETAPA, para verifio de erros */
CREATE OR REPLACE TRIGGER LOG_CDP_RECURETAPA
AFTER DELETE OR INSERT OR UPDATE
ON RECURETAPA FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_GRAV_DESC    VARCHAR2(300);
  V_DESC         VARCHAR2(2000);
  V_LENGTH       FLOAT(10);
  V_CONT_LENGTH  FLOAT(10);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_NRINCREST    VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_GRAV_DESC    := '';
   V_LENGTH       := '';  
   V_CONT_LENGTH  := 1;
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_NRINCREST  := '';
   V_IDTIPOOPER := '';
   V_CDFILLOGOPER := '';
   
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF INSERTING THEN 

         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:NEW.CDFILIAL,'') || ' ' ;
         END IF;

         IF :NEW.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:NEW.CDPRODUTO,'') || ' ' ;
         END IF;

         IF :NEW.CDPROCFABRIC IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProcFabric= ' || NVL(:NEW.CDPROCFABRIC,'') || ' ' ;
         END IF;
         
         IF :NEW.CDETAPAPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEtapaProd= ' || NVL(:NEW.CDETAPAPROD,'') || ' ';
         END IF;

         IF :NEW.CDINSPECAO IS NOT NULL THEN
         V_DESC := V_DESC || 'CdInspecao= ' || NVL(:NEW.CDINSPECAO,'') || ' ';
         END IF;  

         IF :NEW.NRINSPETAPA IS NOT NULL THEN 
            V_DESC := V_DESC || 'NrInspeTapa= ' || NVL(:NEW.NRINSPETAPA,'') || ' ';
         END IF;
         
         IF :NEW.NRRECURETAPA IS NOT NULL THEN
            V_DESC := V_DESC || 'NrRecurEtapa= ' || NVL(:NEW.NRRECURETAPA,'') || ' ';
         END IF;

         IF :NEW.CDEQUIPPRO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEquipaProd= ' || :NEW.CDEQUIPPRO || ' ';
         END IF;

         IF :NEW.CDHABILIDADE IS NOT NULL THEN
            V_DESC := V_DESC || 'CdHabilidade= ' || :NEW.CDHABILIDADE || ' ';
         END IF;

         IF :NEW.NRORDUTRECUR IS NOT NULL THEN
            V_DESC := V_DESC || 'NrOrdUtilRecurEtapa= ' || :NEW.NRORDUTRECUR || ' ';
         END IF;

         IF :NEW.IDRECURETAPA IS NOT NULL THEN
            V_DESC := V_DESC || 'IdRecurEtapa= ' || :NEW.IDRECURETAPA || ' ';
         END IF;

         IF :NEW.QTPRODRECUR IS NOT NULL THEN
            V_DESC := V_DESC || 'QtProdRecur= ' || TO_CHAR(:NEW.QTPRODRECUR) || ' ';
         END IF;
         
         IF :NEW.QTHRUTRECUR IS NOT NULL THEN
            IF :NEW.QTHRUTRECUR < 1 THEN
               V_DESC := V_DESC || 'HrPadraoUtilRecurEtapa= ' || '0' || TO_CHAR(:NEW.QTHRUTRECUR) || ' ';
            ELSE
               V_DESC := V_DESC || 'HrPadraoUtilRecurEtapa= ' || TO_CHAR(:NEW.QTHRUTRECUR) || ' ';
            END IF; 
         END IF;

         IF :NEW.IDTEMPRECUR IS NOT NULL THEN
            V_DESC := V_DESC || 'IdTempRecurEtapa= ' || :NEW.IDTEMPRECUR || ' ';
         END IF;

         IF :NEW.QTRECURETAPA IS NOT NULL THEN
            V_DESC := V_DESC || 'QtRecurEtapa= ' || TO_CHAR(:NEW.QTRECURETAPA) || ' ';
         END IF;
         
         IF :NEW.IDLIBERECU IS NOT NULL THEN
            V_DESC := V_DESC || 'IdLibeRecu= ' || :NEW.IDLIBERECU || ' ';
         END IF;

         IF :NEW.QTHRSETUPRECUR IS NOT NULL THEN
            IF :NEW.QTHRSETUPRECUR < 1 THEN
               V_DESC := V_DESC || 'QtHrSetupRecurso= ' || '0' || TO_CHAR(:NEW.QTHRSETUPRECUR) || ' ';
            ELSE
               V_DESC := V_DESC || 'QtHrSetupRecurso= ' || TO_CHAR(:NEW.QTHRSETUPRECUR) || ' ';
            END IF; 
         END IF;

         IF :NEW.CDGRUPOEQUIPA IS NOT NULL THEN
            V_DESC := V_DESC || 'CdGrupoEquipamento= ' || :NEW.CDGRUPOEQUIPA || ' ' ;
         END IF;

      V_ITPESQ := :NEW.CDFILIAL   || :NEW.CDPRODUTO   || :NEW.CDPROCFABRIC || :NEW.CDETAPAPROD ||
                  :NEW.CDINSPECAO || :NEW.NRINSPETAPA || :NEW.NRRECURETAPA;
                  
      V_IDTIPOOPER := '1';  
      V_CDFILLOGOPER := :NEW.CDFILIAL; 

   END IF;

      IF UPDATING THEN

         IF (:NEW.CDFILIAL <> :OLD.CDFILIAL) THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:NEW.CDFILIAL,'') || ' ' ;
         END IF;

         IF (:NEW.CDPRODUTO <> :OLD.CDPRODUTO) THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:NEW.CDPRODUTO,'') || ' ' ;
         END IF;

         IF (:NEW.CDPROCFABRIC <> :OLD.CDPROCFABRIC) THEN
            V_DESC := V_DESC || 'CdProcFabric= ' || NVL(:NEW.CDPROCFABRIC,'') || ' ' ;
         END IF;
         
         IF (:NEW.CDETAPAPROD <> :OLD.CDETAPAPROD) THEN
            V_DESC := V_DESC || 'CdEtapaProd= ' || NVL(:NEW.CDETAPAPROD,'') || ' ';
         END IF;

         IF (:NEW.CDINSPECAO <> :OLD.CDINSPECAO) THEN
         V_DESC := V_DESC || 'CdInspecao= ' || NVL(:NEW.CDINSPECAO,'') || ' ';
         END IF;  

         IF (:NEW.NRINSPETAPA <> :OLD.NRINSPETAPA) THEN 
            V_DESC := V_DESC || 'NrInspeTapa= ' || NVL(:NEW.NRINSPETAPA,'') || ' ';
         END IF;
         
         IF (:NEW.NRRECURETAPA <> :OLD.NRRECURETAPA) THEN
            V_DESC := V_DESC || 'NrRecurEtapa= ' || NVL(:NEW.NRRECURETAPA,'') || ' ';
         END IF;

         IF (:NEW.CDEQUIPPRO <> :OLD.CDEQUIPPRO) THEN
            V_DESC := V_DESC || 'CdEquipaProd= ' || :NEW.CDEQUIPPRO || ' ';
         END IF;

         IF (:NEW.CDHABILIDADE <> :OLD.CDHABILIDADE) THEN
            V_DESC := V_DESC || 'CdHabilidade= ' || :NEW.CDHABILIDADE || ' ';
         END IF;

         IF (:NEW.NRORDUTRECUR <> :OLD.NRORDUTRECUR) THEN
            V_DESC := V_DESC || 'NrOrdUtilRecurEtapa= ' || :NEW.NRORDUTRECUR || ' ';
         END IF;

         IF (:NEW.IDRECURETAPA <> :OLD.IDRECURETAPA) THEN
            V_DESC := V_DESC || 'IdRecurEtapa= ' || :NEW.IDRECURETAPA || ' ';
         END IF;

         IF (NVL(:NEW.QTPRODRECUR,'-1') <> NVL(:OLD.QTPRODRECUR,'-1')) THEN
            V_DESC := V_DESC || 'QtProdRecur= ' || TO_CHAR(:NEW.QTPRODRECUR) || ' ';
         END IF;
         
         IF (NVL(:NEW.QTHRUTRECUR,'-1') <> NVL(:OLD.QTHRUTRECUR,'-1')) THEN
            IF :NEW.QTHRUTRECUR < 1 THEN
               V_DESC := V_DESC || 'HrPadraoUtilRecurEtapa= ' || '0' || TO_CHAR(:NEW.QTHRUTRECUR) || ' ';
            ELSE
               V_DESC := V_DESC || 'HrPadraoUtilRecurEtapa= ' || TO_CHAR(:NEW.QTHRUTRECUR) || ' ';
            END IF; 
         END IF;

         IF (:NEW.IDTEMPRECUR <> :OLD.IDTEMPRECUR) THEN
            V_DESC := V_DESC || 'IdTempRecurEtapa= ' || :NEW.IDTEMPRECUR || ' ';
         END IF;

         IF (:NEW.QTRECURETAPA <> :OLD.QTRECURETAPA) THEN
            V_DESC := V_DESC || 'QtRecurEtapa= ' || TO_CHAR(:NEW.QTRECURETAPA) || ' ';
         END IF;
         
         IF (NVL(:NEW.IDLIBERECU,'-1') <> NVL(:OLD.IDLIBERECU,'-1')) THEN
            V_DESC := V_DESC || 'IdLibeRecu= ' || :NEW.IDLIBERECU || ' ';
         END IF;

         IF (:NEW.QTHRSETUPRECUR <> :OLD.QTHRSETUPRECUR) THEN
            IF :NEW.QTHRSETUPRECUR < 1 THEN
               V_DESC := V_DESC || 'QtHrSetupRecurso= ' || '0' || TO_CHAR(:NEW.QTHRSETUPRECUR) || ' ';
            ELSE
               V_DESC := V_DESC || 'QtHrSetupRecurso= ' || TO_CHAR(:NEW.QTHRSETUPRECUR) || ' ';
            END IF; 
         END IF;

         IF (:NEW.CDGRUPOEQUIPA <> :OLD.CDGRUPOEQUIPA) THEN
            V_DESC := V_DESC || 'CdGrupoEquipamento= ' || :NEW.CDGRUPOEQUIPA || ' ' ;
         END IF;

      V_ITPESQ := :NEW.CDFILIAL   || :NEW.CDPRODUTO   || :NEW.CDPROCFABRIC || :NEW.CDETAPAPROD ||
                  :NEW.CDINSPECAO || :NEW.NRINSPETAPA || :NEW.NRRECURETAPA;

          V_IDTIPOOPER := '2';    
          V_CDFILLOGOPER := :NEW.CDFILIAL; 
          
      END IF; 

   IF DELETING  THEN

         IF :OLD.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:OLD.CDFILIAL,'') || ' ' ;
         END IF;

         IF :OLD.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:OLD.CDPRODUTO,'') || ' ' ;
         END IF;

         IF :OLD.CDPROCFABRIC IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProcFabric= ' || NVL(:OLD.CDPROCFABRIC,'') || ' ' ;
         END IF;
         
         IF :OLD.CDETAPAPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEtapaProd= ' || NVL(:OLD.CDETAPAPROD,'') || ' ';
         END IF;

         IF :OLD.CDINSPECAO IS NOT NULL THEN
         V_DESC := V_DESC || 'CdInspecao= ' || NVL(:OLD.CDINSPECAO,'') || ' ';
         END IF;  

         IF :OLD.NRINSPETAPA IS NOT NULL THEN 
            V_DESC := V_DESC || 'NrInspeTapa= ' || NVL(:OLD.NRINSPETAPA,'') || ' ';
         END IF;
         
         IF :OLD.NRRECURETAPA IS NOT NULL THEN
            V_DESC := V_DESC || 'NrRecurEtapa= ' || NVL(:OLD.NRRECURETAPA,'') || ' ';
         END IF;

         IF :OLD.CDEQUIPPRO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEquipaProd= ' || :OLD.CDEQUIPPRO || ' ';
         END IF;

         IF :OLD.CDHABILIDADE IS NOT NULL THEN
            V_DESC := V_DESC || 'CdHabilidade= ' || :OLD.CDHABILIDADE || ' ';
         END IF;

         IF :OLD.NRORDUTRECUR IS NOT NULL THEN
            V_DESC := V_DESC || 'NrOrdUtilRecurEtapa= ' || :OLD.NRORDUTRECUR || ' ';
         END IF;

         IF :OLD.IDRECURETAPA IS NOT NULL THEN
            V_DESC := V_DESC || 'IdRecurEtapa= ' || :OLD.IDRECURETAPA || ' ';
         END IF;

         IF :OLD.QTPRODRECUR IS NOT NULL THEN
            V_DESC := V_DESC || 'QtProdRecur= ' || TO_CHAR(:OLD.QTPRODRECUR) || ' ';
         END IF;
         
         IF :OLD.QTHRUTRECUR IS NOT NULL THEN
            IF :OLD.QTHRUTRECUR < 1 THEN
               V_DESC := V_DESC || 'HrPadraoUtilRecurEtapa= ' || '0' || TO_CHAR(:OLD.QTHRUTRECUR) || ' ';
            ELSE
               V_DESC := V_DESC || 'HrPadraoUtilRecurEtapa= ' || TO_CHAR(:OLD.QTHRUTRECUR) || ' ';
            END IF; 
         END IF;

         IF :OLD.IDTEMPRECUR IS NOT NULL THEN
            V_DESC := V_DESC || 'IdTempRecurEtapa= ' || :OLD.IDTEMPRECUR || ' ';
         END IF;

         IF :OLD.QTRECURETAPA IS NOT NULL THEN
            V_DESC := V_DESC || 'QtRecurEtapa= ' || TO_CHAR(:OLD.QTRECURETAPA) || ' ';
         END IF;
         
         IF :OLD.IDLIBERECU IS NOT NULL THEN
            V_DESC := V_DESC || 'IdLibeRecu= ' || :OLD.IDLIBERECU || ' ';
         END IF;

         IF :OLD.QTHRSETUPRECUR IS NOT NULL THEN
            IF :OLD.QTHRSETUPRECUR < 1 THEN
               V_DESC := V_DESC || 'QtHrSetupRecurso= ' || '0' || TO_CHAR(:OLD.QTHRSETUPRECUR) || ' ';
            ELSE
               V_DESC := V_DESC || 'QtHrSetupRecurso= ' || TO_CHAR(:OLD.QTHRSETUPRECUR) || ' ';
            END IF; 
         END IF;

         IF :OLD.CDGRUPOEQUIPA IS NOT NULL THEN
            V_DESC := V_DESC || 'CdGrupoEquipamento= ' || :OLD.CDGRUPOEQUIPA || ' ' ;
         END IF;
         
      V_ITPESQ := :OLD.CDFILIAL   || :OLD.CDPRODUTO   || :OLD.CDPROCFABRIC || :OLD.CDETAPAPROD ||
                  :OLD.CDINSPECAO || :OLD.NRINSPETAPA || :OLD.NRRECURETAPA;

      V_IDTIPOOPER := '3';
      V_CDFILLOGOPER := :OLD.CDFILIAL;

   END IF;  
   
   IF NOT (V_DESC IS NULL) THEN   
   
      V_LENGTH := LENGTH(V_DESC);

      WHILE V_LENGTH >= V_CONT_LENGTH LOOP

         V_GRAV_DESC := SUBSTR(V_DESC, V_CONT_LENGTH, 300);
         V_CONT_LENGTH := V_CONT_LENGTH + 300;

         INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                                DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
                      VALUES  ('RECURETAPA', SYSDATE ,    NVL(V_NMOPERADOR,' '),
                                V_IDTIPOOPER,   V_GRAV_DESC, V_ITPESQ,
                                V_DSSERVERRDM, V_DSREMOTEADDR,  V_DSREMOTEHOST,
                                V_DSSERVMETHOD,   V_DSREMOTEOPER, V_CDFILLOGOPER); 
  
      END LOOP;  
   END IF;
END;

/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_CDP_RECURETAPA','5.07.001'); END;
/    
