/*
NOME: 0021_DENSTPO_EXPORTA_MOV_ESTOQUE.SQL

DESCRIO: Procedimento para exportao das movimentaes de Estoque.

CRIAO: 26/08/2008 - Fabrcio Marcelo da Silva

@C:\web_550\sql\end_conv\oracle\clientes\den\0007_DENSTPO_EXPORTA_MOV_ESTOQUE.SQL

RAISE_APPLICATION_ERROR(-20501, '' , TRUE);
*/

CREATE OR REPLACE PROCEDURE EXPORTA_MOV_ESTOQUE_OFICIAL(
     P_DTINICIAL IN LANCTOESTOQ.DTLANCESTQ%TYPE,
     P_DTFINAL   IN LANCTOESTOQ.DTLANCESTQ%TYPE,
     P_IDFECHA   IN NOTAFISCAL.IDBLOQUEADO%TYPE DEFAULT NULL)
AS
   V_DTGRV         DATE;
   V_HRGRV         VARCHAR2(04);

   V_FILIAL        VARCHAR2(10);
   V_NRMOVIESTQ    VARCHAR2(20);
   V_TM            VARCHAR2(03);
   V_QTDEAJUS      FLOAT;
   V_VRAJUS        FLOAT;

   V_WG_IDMVEST    INTEGER;
   V_NOVOCODIGO    INTEGER;

   V_WG_QUANT      FLOAT;
   V_WG_CUSTO      FLOAT;
BEGIN
   V_DTGRV := NULL;
   V_HRGRV := NULL;
   /* Retorna data e hora de exportao */
   BEGIN
      SELECT TO_DATE(SYSDATE), TO_CHAR(SYSDATE,'HH24MI')
      INTO V_DTGRV, V_HRGRV
      FROM DUAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_DTGRV := NULL;
         V_HRGRV := NULL;
   END;

   FOR C_FILI IN (SELECT DISTINCT(FI.CDFILIAL), DTPROCESSA AS USR_DTFECHADIA
                    FROM FILGRUPFILI FI, PARAMFILIAL P
                   WHERE (FI.USR_IDPROTHEUS = 'S')
                     AND (FI.CDFILIAL = P.CDFILIAL)
                     AND (P_IDFECHA IS NULL)

                   UNION ALL

                  SELECT DISTINCT (FI.CDFILIAL) CDFILIAL, USR_DTFECHADIA
                    FROM FILGRUPFILI FI, USR_FECHAMENTO F
                   WHERE (FI.USR_IDPROTHEUS = 'S')
                     AND (P_IDFECHA = 'S')
                     AND (FI.CDFILIAL = F.USR_CDFILIAL)
                   ORDER BY CDFILIAL) LOOP

      /* Verificao dos lanamentos de estoque (retirada) */
      FOR C_MOVESTO IN (SELECT L.CDFILIAL,
                               L.NRLANCESTQ,
                               L.CDFILIMOVI,
                               P.CDARVPROD,
                               TO_DATE(L.DTLANCESTQ) AS DTLANCESTQ,
                               L.NRLANCESTQ AS DOC,
                               SUM(I.QTLANCTOEST) AS QTDEMOVI,
                               SUM(I.QTTOTLANCTO*I.VRUNILANCTO) AS VALRMOVI
                          FROM LANCTOESTOQ L, ITLANCTOEST I, PRODUTO P,
                               RETIRADAESTO RE
                         WHERE (L.CDFILIMOVI = C_FILI.CDFILIAL)
                           AND (L.DTLANCESTQ BETWEEN P_DTINICIAL AND P_DTFINAL)
                           AND (L.DTLANCESTQ < C_FILI.USR_DTFECHADIA OR P_IDFECHA IS NULL)
                           AND (L.IDTPLANCTO = '3')
                           AND (NVL(L.USR_IDEXPORTA, 'S') = 'S')
                           AND (L.USR_DTEXPORTA IS NULL)
                           AND (I.CDFILIAL   = L.CDFILIAL)
                           AND (I.NRLANCESTQ = L.NRLANCESTQ)
                           AND (NVL(I.IDEVOLESTOQ, 'S') = 'S')
                           AND (I.CDPRODUTO = P.CDPRODUTO)
                           AND (L.CDFILIAL = RE.CDFILIALLAN)
                           AND (L.NRLANCESTQ = RE.NRLANCESTQ)
                         GROUP BY L.CDFILIAL,
                                  L.NRLANCESTQ,
                                  L.CDFILIMOVI,
                                  P.CDARVPROD,
                                  TO_DATE(L.DTLANCESTQ),
                                  L.NRLANCESTQ
                         UNION

                        SELECT L.CDFILIAL,
                               L.NRLANCESTQ,
                               L.CDFILIMOVI,
                               P.CDARVPROD,
                               TO_DATE(L.DTLANCESTQ) AS DTLANCESTQ,
                               L.NRLANCESTQ AS DOC,
                               SUM(I.QTLANCTOEST) AS QTDEMOVI,
                               SUM(I.QTTOTLANCTO*I.VRUNILANCTO) AS VALRMOVI
                          FROM LANCTOESTOQ L, ITLANCTOEST I, PRODUTO P,
                               RETIRADA R
                         WHERE (L.CDFILIMOVI = C_FILI.CDFILIAL)
                           AND (L.DTLANCESTQ BETWEEN P_DTINICIAL AND P_DTFINAL)
                           AND (L.DTLANCESTQ < C_FILI.USR_DTFECHADIA OR P_IDFECHA IS NULL)
                           AND (L.IDTPLANCTO = '3')
                           AND (NVL(L.USR_IDEXPORTA, 'S') = 'S')
                           AND (L.USR_DTEXPORTA IS NULL)
                           AND (I.CDFILIAL   = L.CDFILIAL)
                           AND (I.NRLANCESTQ = L.NRLANCESTQ)
                           AND (NVL(I.IDEVOLESTOQ, 'S') = 'S')
                           AND (I.CDPRODUTO = P.CDPRODUTO)
                           AND (L.CDFILIAL = R.CDFILANCESTQ)
                           AND (L.NRLANCESTQ = R.NRLANCESTQ)
                         GROUP BY L.CDFILIAL,
                                  L.NRLANCESTQ,
                                  L.CDFILIMOVI,
                                  P.CDARVPROD,
                                  TO_DATE(L.DTLANCESTQ),
                                  L.NRLANCESTQ)
      LOOP
         V_FILIAL := NULL;

         SELECT MAX(CDGRUPFILI)
           INTO V_FILIAL
           FROM FILGRUPFILI
          WHERE CDFILIAL = C_MOVESTO.CDFILIMOVI
            AND USR_IDPROTHEUS = 'S';

         IF NOT V_FILIAL IS NULL           AND
            NOT C_MOVESTO.VALRMOVI IS NULL THEN

            V_WG_IDMVEST := 0;

            /* Retorna o sequencial para a tabela */
            BEGIN
               SELECT WG_IDMVEST.NEXTVAL
                 INTO V_NOVOCODIGO
                 FROM DUAL;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_NOVOCODIGO := 1;
            END;

            SELECT NVL(MAX(WG_IDMVEST),0)
              INTO V_WG_IDMVEST
              FROM USR_ZWG
             WHERE CDFILIAL = C_MOVESTO.CDFILIAL
               AND NRLANCESTQ = C_MOVESTO.NRLANCESTQ
               AND WG_CC = C_MOVESTO.CDFILIMOVI
               AND WG_COD = SUBSTR(C_MOVESTO.CDARVPROD,1,15)
               AND WG_EMISSAO = C_MOVESTO.DTLANCESTQ
               AND WG_DOC = SUBSTR(C_MOVESTO.DOC,2,9)
               AND WG_TPEDI = '1';

            IF V_WG_IDMVEST = 0 THEN
               /* Insere movimentao de estoque */
               INSERT INTO USR_ZWG
                  (WG_IDMVEST, CDFILIAL, NRLANCESTQ, WG_EMPRESA, WG_FILIAL, WG_TM, WG_COD, WG_LOCAL, WG_QUANT,
                   WG_EMISSAO, WG_CC, WG_CUSTO, WG_DOC, WG_USUARIO, WG_CONTA, WG_ITEMCTA, WG_CLVL,
                   WG_LOTECTL, WG_NUMLOTE, WG_DTVALID, WG_TPEDI, WG_DTGRV, WG_HRGRV)
               VALUES
                  (V_NOVOCODIGO, C_MOVESTO.CDFILIAL, C_MOVESTO.NRLANCESTQ, SUBSTR(V_FILIAL, 7, 2), SUBSTR(V_FILIAL, 9, 2), '503', SUBSTR(C_MOVESTO.CDARVPROD,1,15), NULL, C_MOVESTO.QTDEMOVI,
                   C_MOVESTO.DTLANCESTQ, C_MOVESTO.CDFILIMOVI, C_MOVESTO.VALRMOVI, SUBSTR(C_MOVESTO.DOC,2,9), NULL, NULL, NULL, NULL,
                   NULL, NULL, NULL, '1', V_DTGRV, V_HRGRV);
            ELSE
               V_WG_QUANT := 0;
               V_WG_CUSTO := 0;

               SELECT MAX(WG_QUANT), MAX(WG_CUSTO)
                 INTO V_WG_QUANT, V_WG_CUSTO
                 FROM USR_ZWG
                WHERE WG_IDMVEST = V_WG_IDMVEST;

               /* Exclui e inclui novamente a movimentao de estoque */
               INSERT INTO USR_ZWG
                  (WG_IDMVEST, CDFILIAL, NRLANCESTQ, WG_EMPRESA, WG_FILIAL, WG_TM, WG_COD, WG_LOCAL, WG_QUANT,
                   WG_EMISSAO, WG_CC, WG_CUSTO, WG_DOC, WG_USUARIO, WG_CONTA, WG_ITEMCTA, WG_CLVL,
                   WG_LOTECTL, WG_NUMLOTE, WG_DTVALID, WG_TPEDI, WG_DTGRV, WG_HRGRV)
               VALUES
                  (V_NOVOCODIGO, C_MOVESTO.CDFILIAL, C_MOVESTO.NRLANCESTQ, SUBSTR(V_FILIAL, 7, 2), SUBSTR(V_FILIAL, 9, 2), '503', SUBSTR(C_MOVESTO.CDARVPROD,1,15), NULL, V_WG_QUANT,
                   C_MOVESTO.DTLANCESTQ, C_MOVESTO.CDFILIMOVI, V_WG_CUSTO, SUBSTR(C_MOVESTO.DOC,2,9), NULL, NULL, NULL, NULL,
                   NULL, NULL, NULL, '2', V_DTGRV, V_HRGRV);

               /* Retorna o sequencial para a tabela */
               BEGIN
                  SELECT WG_IDMVEST.NEXTVAL
                    INTO V_NOVOCODIGO
                    FROM DUAL;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_NOVOCODIGO := 1;
               END;

               /* Inclui movimentao de estoque */
               INSERT INTO USR_ZWG
                  (WG_IDMVEST, CDFILIAL, NRLANCESTQ, WG_EMPRESA, WG_FILIAL, WG_TM, WG_COD, WG_LOCAL, WG_QUANT,
                   WG_EMISSAO, WG_CC, WG_CUSTO, WG_DOC, WG_USUARIO, WG_CONTA, WG_ITEMCTA, WG_CLVL,
                   WG_LOTECTL, WG_NUMLOTE, WG_DTVALID, WG_TPEDI, WG_DTGRV, WG_HRGRV)
               VALUES
                  (V_NOVOCODIGO, C_MOVESTO.CDFILIAL, C_MOVESTO.NRLANCESTQ, SUBSTR(V_FILIAL, 7, 2), SUBSTR(V_FILIAL, 9, 2), '503', SUBSTR(C_MOVESTO.CDARVPROD,1,15), NULL, C_MOVESTO.QTDEMOVI,
                   C_MOVESTO.DTLANCESTQ, C_MOVESTO.CDFILIMOVI, C_MOVESTO.VALRMOVI, SUBSTR(C_MOVESTO.DOC,2,9), NULL, NULL, NULL, NULL,
                   NULL, NULL, NULL, '1', V_DTGRV, V_HRGRV);
            END IF;

            /* Inclui a data de exportao para os lancamentos de estoque */
            UPDATE LANCTOESTOQ
               SET USR_IDEXPORTA = 'N',
                   USR_DTEXPORTA = SYSDATE
             WHERE CDFILIAL = C_MOVESTO.CDFILIAL
               AND NRLANCESTQ = C_MOVESTO.NRLANCESTQ;
         END IF;
      END LOOP;

      SELECT LPAD(ABS(ROUND(DBMS_RANDOM.VALUE(9999,9999999999))),10,'0')
      INTO V_NRMOVIESTQ
      FROM DUAL;

      /* Retorna a mov. de estoque (ajustes) */
      GERA_AJUSTMOV(C_FILI.CDFILIAL,' ',' ',' ', 1, P_DTINICIAL, P_DTFINAL, '1', 'Zzzzz', 3, 1,V_NRMOVIESTQ);

      FOR C_AJUS IN (SELECT L.CDFILIAL,
                            L.NRLANCESTQ,
                            L.CDFILIMOVI,
                            P.CDARVPROD,
                            TO_DATE(R.DTLANCMOVIEST) AS DTLANCESTQ,
                            L.NRLANCESTQ AS DOC,
                            SUM((DECODE((I.QTLANCTOEST - R.QTTOTALANT)* -1, ABS(I.QTLANCTOEST - R.QTTOTALANT),(I.QTLANCTOEST - R.QTTOTALANT),0))) AS QTNEGATIVO,
                            SUM((DECODE((I.QTLANCTOEST - R.QTTOTALANT)* -1, ABS(I.QTLANCTOEST - R.QTTOTALANT), 0, (I.QTLANCTOEST - R.QTTOTALANT)))) AS QTPOSITIVO,
                            SUM((DECODE((I.QTLANCTOEST - R.QTTOTALANT)* -1, ABS(I.QTLANCTOEST - R.QTTOTALANT),(I.QTLANCTOEST - R.QTTOTALANT),0) *(R.VRCUSTMEDI))) AS VRNEGATIVO,
                            SUM((DECODE((I.QTLANCTOEST - R.QTTOTALANT)* -1, ABS(I.QTLANCTOEST - R.QTTOTALANT), 0, (I.QTLANCTOEST - R.QTTOTALANT)) *(R.VRCUSTMEDI))) AS VRPOSITIVO
                       FROM LANCTOESTOQ L, ITLANCTOEST I, RELAT_MOVIEST R, PRODUTO P
                      WHERE (L.CDFILIMOVI = C_FILI.CDFILIAL)
                        AND (L.DTLANCESTQ BETWEEN P_DTINICIAL AND P_DTFINAL)
                        AND (L.IDTPLANCTO = '1')
                        AND (NVL(L.USR_IDEXPORTA, 'S') = 'S')
                        AND (L.USR_DTEXPORTA IS NULL)
                        AND (L.CDFILIAL = I.CDFILIAL)
                        AND (L.NRLANCESTQ = I.NRLANCESTQ)
                        AND (NVL(I.IDEVOLESTOQ, 'S') = 'S')
                        AND (R.CDFILIMOVIEST = C_FILI.CDFILIAL)
                        AND (R.NRRELATMOVI = V_NRMOVIESTQ)
                        AND (R.DTLANCMOVIEST BETWEEN P_DTINICIAL AND P_DTFINAL)
                        AND (R.NRLANCMOVIEST = I.NRLANCESTQ)
                        AND (R.NRSEQUMOVIEST = I.NRSEQUITEM)
                        AND (R.IDTIPOMOVIEST = '1')
                        AND (I.CDPRODUTO = P.CDPRODUTO)
                      GROUP BY L.CDFILIAL,
                               L.NRLANCESTQ,
                               L.CDFILIMOVI,
                               P.CDARVPROD,
                               TO_DATE(R.DTLANCMOVIEST),
                               L.NRLANCESTQ) LOOP

         V_FILIAL := NULL;

         SELECT MAX(CDGRUPFILI)
           INTO V_FILIAL
           FROM FILGRUPFILI
          WHERE CDFILIAL = C_AJUS.CDFILIMOVI
            AND USR_IDPROTHEUS = 'S';

         IF NOT V_FILIAL IS NULL THEN

            V_WG_IDMVEST := 0;

            /* Retorna o sequencial para a tabela */
            BEGIN
               SELECT WG_IDMVEST.NEXTVAL
                 INTO V_NOVOCODIGO
                 FROM DUAL;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_NOVOCODIGO := 1;
            END;

            IF C_AJUS.QTPOSITIVO = 0 THEN
               V_TM := '506';
               V_QTDEAJUS := C_AJUS.QTNEGATIVO;
               V_VRAJUS   := C_AJUS.VRNEGATIVO;
            ELSE
               V_TM := '006';
               V_QTDEAJUS := C_AJUS.QTPOSITIVO;
               V_VRAJUS   := C_AJUS.VRPOSITIVO;
            END IF;

            SELECT NVL(MAX(WG_IDMVEST),0)
              INTO V_WG_IDMVEST
              FROM USR_ZWG
             WHERE CDFILIAL = C_AJUS.CDFILIAL
               AND NRLANCESTQ = C_AJUS.NRLANCESTQ
               AND WG_CC = C_AJUS.CDFILIMOVI
               AND WG_COD = SUBSTR(C_AJUS.CDARVPROD,1,15)
               AND WG_EMISSAO = C_AJUS.DTLANCESTQ
               AND WG_DOC = SUBSTR(C_AJUS.DOC,2,9)
               AND WG_TPEDI = '1';

            IF V_WG_IDMVEST = 0 THEN
               /* Insere movimentao de estoque */
               INSERT INTO USR_ZWG
                  (WG_IDMVEST, CDFILIAL, NRLANCESTQ, WG_EMPRESA, WG_FILIAL, WG_TM, WG_COD, WG_LOCAL, WG_QUANT,
                   WG_EMISSAO, WG_CC, WG_CUSTO, WG_DOC, WG_USUARIO, WG_CONTA, WG_ITEMCTA, WG_CLVL,
                   WG_LOTECTL, WG_NUMLOTE, WG_DTVALID, WG_TPEDI, WG_DTGRV, WG_HRGRV)
               VALUES
                  (V_NOVOCODIGO, C_AJUS.CDFILIAL, C_AJUS.NRLANCESTQ, SUBSTR(V_FILIAL, 7, 2), SUBSTR(V_FILIAL, 9, 2), V_TM, SUBSTR(C_AJUS.CDARVPROD,1,15), NULL, ABS(V_QTDEAJUS),
                   C_AJUS.DTLANCESTQ, C_AJUS.CDFILIMOVI, ABS(V_VRAJUS), SUBSTR(C_AJUS.DOC,2,9), NULL, NULL, NULL, NULL,
                   NULL, NULL, NULL, '1', V_DTGRV, V_HRGRV);
            ELSE
               V_WG_QUANT := 0;
               V_WG_CUSTO := 0;

               SELECT MAX(WG_QUANT), MAX(WG_CUSTO)
                 INTO V_WG_QUANT, V_WG_CUSTO
                 FROM USR_ZWG
                WHERE WG_IDMVEST = V_WG_IDMVEST;

               /* Exclui e inclui novamente a movimentao de estoque */
               INSERT INTO USR_ZWG
                  (WG_IDMVEST, CDFILIAL, NRLANCESTQ, WG_EMPRESA, WG_FILIAL, WG_TM, WG_COD, WG_LOCAL, WG_QUANT,
                   WG_EMISSAO, WG_CC, WG_CUSTO, WG_DOC, WG_USUARIO, WG_CONTA, WG_ITEMCTA, WG_CLVL,
                   WG_LOTECTL, WG_NUMLOTE, WG_DTVALID, WG_TPEDI, WG_DTGRV, WG_HRGRV)
               VALUES
                  (V_NOVOCODIGO, C_AJUS.CDFILIAL, C_AJUS.NRLANCESTQ, SUBSTR(V_FILIAL, 7, 2), SUBSTR(V_FILIAL, 9, 2), V_TM, SUBSTR(C_AJUS.CDARVPROD,1,15), NULL, V_WG_QUANT,
                   C_AJUS.DTLANCESTQ, C_AJUS.CDFILIMOVI, V_WG_CUSTO, SUBSTR(C_AJUS.DOC,2,9), NULL, NULL, NULL, NULL,
                   NULL, NULL, NULL, '2', V_DTGRV, V_HRGRV);

               /* Retorna o sequencial para a tabela */
               BEGIN
                  SELECT WG_IDMVEST.NEXTVAL
                    INTO V_NOVOCODIGO
                    FROM DUAL;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_NOVOCODIGO := 1;
               END;

               /* Inclui movimentao de estoque */
               INSERT INTO USR_ZWG
                  (WG_IDMVEST, CDFILIAL, NRLANCESTQ, WG_EMPRESA, WG_FILIAL, WG_TM, WG_COD, WG_LOCAL, WG_QUANT,
                   WG_EMISSAO, WG_CC, WG_CUSTO, WG_DOC, WG_USUARIO, WG_CONTA, WG_ITEMCTA, WG_CLVL,
                   WG_LOTECTL, WG_NUMLOTE, WG_DTVALID, WG_TPEDI, WG_DTGRV, WG_HRGRV)
               VALUES
                  (V_NOVOCODIGO, C_AJUS.CDFILIAL, C_AJUS.NRLANCESTQ, SUBSTR(V_FILIAL, 7, 2), SUBSTR(V_FILIAL, 9, 2), V_TM, SUBSTR(C_AJUS.CDARVPROD,1,15), NULL, ABS(V_QTDEAJUS),
                   C_AJUS.DTLANCESTQ, C_AJUS.CDFILIMOVI, ABS(V_VRAJUS), SUBSTR(C_AJUS.DOC,2,9), NULL, NULL, NULL, NULL,
                   NULL, NULL, NULL, '1', V_DTGRV, V_HRGRV);
            END IF;

            /* Inclui a data de exportao para os lancamentos de estoque */
            UPDATE LANCTOESTOQ
               SET USR_IDEXPORTA = 'N',
                   USR_DTEXPORTA = SYSDATE
             WHERE CDFILIAL = C_AJUS.CDFILIAL
               AND NRLANCESTQ = C_AJUS.NRLANCESTQ;
         END IF;
      END LOOP;


      /* Gera movimentacao das saidas efetuadas atraves do tipo de operacao 10 */
      FOR C_MOVSAI IN (SELECT N.CDFILIAL AS CDFILINF,
                              N.NRLANCTONF,
                              L.CDFILIAL,
                              L.NRLANCESTQ,
                              N.CDFILIEMIT AS CDFILIMOVI,
                              N.CDFILIRECE,
                              P.CDARVPROD,
                              TO_DATE(N.DTENTRSAID) AS DTLANCESTQ,
                              L.NRLANCESTQ AS DOC,
                              SUM(I.QTITEMPROD) AS QTDEMOVI,
                              SUM(NVL(I.VRTOTAITEM,0)) AS VALRMOVI
                         FROM NOTAFISCAL N, ITEMPRODUTO I, PRODUTO P, LANCTOESTOQ L
                        WHERE (N.CDFILIEMIT = C_FILI.CDFILIAL)
                          AND (N.IDENTRSAIDOP = 'S')
                          AND (N.DTENTRSAID BETWEEN P_DTINICIAL AND P_DTFINAL)
                          AND (N.IDSISTEMA IN ('DFS','FAI'))
                          AND (N.CDTIPOOPER = '10')
                          AND (N.USR_DTEXPORTACAO IS NULL)
                          AND (I.CDFILIAL = N.CDFILIAL)
                          AND (I.NRLANCTONF = N.NRLANCTONF)
                          AND (L.CDFILIAL = N.CDFILIAL)
                          AND (L.NRLANCTONF = N.NRLANCTONF)
                          AND (I.CDPRODUTO = P.CDPRODUTO)
                        GROUP BY N.CDFILIAL,
                                 N.NRLANCTONF,
                                 L.CDFILIAL,
                                 L.NRLANCESTQ,
                                 N.CDFILIEMIT,
                                 N.CDFILIRECE,
                                 P.CDARVPROD,
                                 TO_DATE(N.DTENTRSAID),
                                 L.NRLANCESTQ
                        ORDER BY L.CDFILIAL, L.NRLANCESTQ, P.CDARVPROD) LOOP

         V_FILIAL := NULL;

         SELECT MAX(CDGRUPFILI)
           INTO V_FILIAL
           FROM FILGRUPFILI
          WHERE CDFILIAL = C_MOVSAI.CDFILIMOVI
            AND USR_IDPROTHEUS = 'S';

         IF NOT V_FILIAL IS NULL AND
            NOT C_MOVSAI.VALRMOVI = 0 THEN

            V_WG_IDMVEST := 0;

            /* Retorna o sequencial para a tabela */
            BEGIN
               SELECT WG_IDMVEST.NEXTVAL
                 INTO V_NOVOCODIGO
                 FROM DUAL;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_NOVOCODIGO := 1;
            END;

            V_TM := '510';

            SELECT NVL(MAX(WG_IDMVEST),0)
              INTO V_WG_IDMVEST
              FROM USR_ZWG
             WHERE CDFILIAL = C_MOVSAI.CDFILIAL
               AND NRLANCTONF = C_MOVSAI.NRLANCTONF
               AND NRLANCESTQ = C_MOVSAI.NRLANCESTQ
               AND WG_CC = C_MOVSAI.CDFILIMOVI
               AND WG_COD = SUBSTR(C_MOVSAI.CDARVPROD,1,15)
               AND WG_EMISSAO = C_MOVSAI.DTLANCESTQ
               AND WG_DOC = SUBSTR(C_MOVSAI.DOC,2,9)
               AND WG_TPEDI = '1';

            IF V_WG_IDMVEST = 0 THEN
               /* Insere movimentao de estoque */
               INSERT INTO USR_ZWG
                  (WG_IDMVEST, CDFILIAL, NRLANCTONF, NRLANCESTQ, WG_EMPRESA, WG_FILIAL, WG_TM, WG_COD, WG_LOCAL, WG_QUANT,
                   WG_EMISSAO, WG_CC, WG_CUSTO, WG_DOC, WG_USUARIO, WG_CONTA, WG_ITEMCTA, WG_CLVL,
                   WG_LOTECTL, WG_NUMLOTE, WG_DTVALID, WG_TPEDI, WG_DTGRV, WG_HRGRV)
               VALUES
                  (V_NOVOCODIGO, C_MOVSAI.CDFILIAL, C_MOVSAI.NRLANCTONF, C_MOVSAI.NRLANCESTQ, SUBSTR(V_FILIAL, 7, 2), SUBSTR(V_FILIAL, 9, 2), V_TM, SUBSTR(C_MOVSAI.CDARVPROD,1,15), C_MOVSAI.CDFILIRECE, C_MOVSAI.QTDEMOVI,
                   C_MOVSAI.DTLANCESTQ, C_MOVSAI.CDFILIMOVI, C_MOVSAI.VALRMOVI, SUBSTR(C_MOVSAI.DOC,2,9), NULL, NULL, NULL, NULL,
                   NULL, NULL, NULL, '1', V_DTGRV, V_HRGRV);
            ELSE
               V_WG_QUANT := 0;
               V_WG_CUSTO := 0;

               SELECT MAX(WG_QUANT), MAX(WG_CUSTO)
                 INTO V_WG_QUANT, V_WG_CUSTO
                 FROM USR_ZWG
                WHERE WG_IDMVEST = V_WG_IDMVEST;

               /* Exclui e inclui novamente a movimentao de estoque */
               INSERT INTO USR_ZWG
                  (WG_IDMVEST, CDFILIAL, NRLANCTONF, NRLANCESTQ, WG_EMPRESA, WG_FILIAL, WG_TM, WG_COD, WG_LOCAL, WG_QUANT,
                   WG_EMISSAO, WG_CC, WG_CUSTO, WG_DOC, WG_USUARIO, WG_CONTA, WG_ITEMCTA, WG_CLVL,
                   WG_LOTECTL, WG_NUMLOTE, WG_DTVALID, WG_TPEDI, WG_DTGRV, WG_HRGRV)
               VALUES
                  (V_NOVOCODIGO, C_MOVSAI.CDFILIAL, C_MOVSAI.NRLANCTONF, C_MOVSAI.NRLANCESTQ, SUBSTR(V_FILIAL, 7, 2), SUBSTR(V_FILIAL, 9, 2), V_TM, SUBSTR(C_MOVSAI.CDARVPROD,1,15), C_MOVSAI.CDFILIRECE, V_WG_QUANT,
                   C_MOVSAI.DTLANCESTQ, C_MOVSAI.CDFILIMOVI, V_WG_CUSTO, SUBSTR(C_MOVSAI.DOC,2,9), NULL, NULL, NULL, NULL,
                   NULL, NULL, NULL, '2', V_DTGRV, V_HRGRV);

               /* Retorna o sequencial para a tabela */
               BEGIN
                  SELECT WG_IDMVEST.NEXTVAL
                    INTO V_NOVOCODIGO
                    FROM DUAL;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_NOVOCODIGO := 1;
               END;

               /* Inclui movimentao de estoque */
               INSERT INTO USR_ZWG
                  (WG_IDMVEST, CDFILIAL, NRLANCTONF, NRLANCESTQ, WG_EMPRESA, WG_FILIAL, WG_TM, WG_COD, WG_LOCAL, WG_QUANT,
                   WG_EMISSAO, WG_CC, WG_CUSTO, WG_DOC, WG_USUARIO, WG_CONTA, WG_ITEMCTA, WG_CLVL,
                   WG_LOTECTL, WG_NUMLOTE, WG_DTVALID, WG_TPEDI, WG_DTGRV, WG_HRGRV)
               VALUES
                  (V_NOVOCODIGO, C_MOVSAI.CDFILIAL, C_MOVSAI.NRLANCTONF, C_MOVSAI.NRLANCESTQ, SUBSTR(V_FILIAL, 7, 2), SUBSTR(V_FILIAL, 9, 2), V_TM, SUBSTR(C_MOVSAI.CDARVPROD,1,15), C_MOVSAI.CDFILIRECE, C_MOVSAI.QTDEMOVI,
                   C_MOVSAI.DTLANCESTQ, C_MOVSAI.CDFILIMOVI, C_MOVSAI.VALRMOVI, SUBSTR(C_MOVSAI.DOC,2,9), NULL, NULL, NULL, NULL,
                   NULL, NULL, NULL, '1', V_DTGRV, V_HRGRV);
            END IF;

            /* Inclui a data de exportao para os documentos exportados*/
            UPDATE NOTAFISCAL
               SET USR_DTEXPORTACAO = V_DTGRV
             WHERE CDFILIAL = C_MOVSAI.CDFILINF
               AND NRLANCTONF = C_MOVSAI.NRLANCTONF;
         END IF;
      END LOOP;
      COMMIT;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_MOV_ESTOQUE_OFICIAL','5.50.XXX'); END;
/

